
/*
    xsit - screen mate for X11
    Copyright (C) 2003 Jrme Laheurte <fraca7@free.fr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* $Id: geom.h,v 1.3 2003/08/04 14:37:13 jerome Exp $ */

#ifndef _geom_h_
#define _geom_h_

#include <glib.h>

/*
  Structure reprsentant une position statique par rapport  une fentre
  Deux champs spars par '/', le premier pour la position horizontale, le
  2me verticale.
  Chaque champ a la syntaxe suivante:
  * soit un signe '+' ou '-' suivi d'un nombre de pixels reprsentant la position
    du coin suprieur gauche du sitter par rapport au bord gauche de la fentre
    (signe '+') ou au bord droit de la fentre (signe '-')
  * soit un pourcentage suivi du signe '%' reprsentant la position relative du
    sitter
*/

typedef struct {
  gint isXRel; /* 0 = relatif, -1 = gauche, 1 = droite */
  gint isYRel;
  gint xVal;
  gint yVal;
} geometry;

/* NULL en cas d'erreur de syntaxe */

geometry *geometry_new(gchar*);
#define geometry_free(g) g_free(g)

/*
  Retourne l'offset en X par rapport au bord gauche de la fentre,
  en fonction de la largeur de la fentre et de la largeur
  du sitter
*/

gint geometry_get_x(geometry*, guint, guint);

/*
  Idem en Y par rapport au bord suprieur, fn hauteur
*/

gint geometry_get_y(geometry*, guint, guint);

#endif
