
/*
    xsit - screen mate for X11
    Copyright (C) 2003 Jrme Laheurte <fraca7@free.fr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* $Id: pluginsitter.c,v 1.4 2003/08/04 14:40:16 jerome Exp $ */

#include "pluginsitter.h"
#include "utils.h"

typedef struct {
  sitter super;
  GModule *module;
} plugin_sitter;

sitter *plugin_sitter_new(gchar *line) {
  plugin_sitter *r;
  gint (*f)(void);
  void (*i)(gchar*);

  token_string *tk = token_string_new(line, ':');

  if (!token_string_has_more(tk)) {
    token_string_free(tk);
    return NULL;
  }

  r = g_new(plugin_sitter, 1);
  r->module = g_module_open(token_string_next(tk), 0);
  if (r == NULL) {
    g_free(r);
    return NULL;
  }

  /* on fait confiance au programmeur du plugin... */

  g_module_symbol(r->module, "init", (gpointer*)(&i));
  (*i)(token_string_remain(tk));
  token_string_free(tk);

  g_module_symbol(r->module, "getWidth", (gpointer*)(&f));
  r->super.w = (*f)();

  g_module_symbol(r->module, "getHeight", (gpointer*)(&f));
  r->super.h = (*f)();

  g_module_symbol(r->module,
		  "next_frame",
		  (gpointer*)(&(r->super.next_frame)));

  g_module_symbol(r->module,
		  "get_current_frame",
		  (gpointer*)(&(r->super.get_current_frame)));

  g_module_symbol(r->module,
		  "get_next_timeout",
		  (gpointer*)(&(r->super.get_next_timeout)));

  g_module_symbol(r->module,
		  "get_x",
		  (gpointer*)(&(r->super.get_x)));

  g_module_symbol(r->module,
		  "get_y",
		  (gpointer*)(&(r->super.get_y)));

  g_module_symbol(r->module,
		  "structure_notify",
		  (gpointer*)(&(r->super.structure_notify)));

  g_module_symbol(r->module,
		  "focus_notify",
		  (gpointer*)(&(r->super.focus_notify)));

  return (sitter*)r;
}

void plugin_sitter_free(sitter *s) {
  void (*f)(sitter*);

  plugin_sitter *st = (plugin_sitter*)s;
  g_module_symbol(st->module,
		  "destroy",
		  (gpointer*)(&f));
  (*f)((sitter*)st);

  g_module_close(st->module);
  sitter_free(s);
}

static const char* _rcsid_pluginsitter __attribute__((unused)) = "$Id: pluginsitter.c,v 1.4 2003/08/04 14:40:16 jerome Exp $";
