
/*
    xsit - screen mate for X11
    Copyright (C) 2003 Jrme Laheurte <fraca7@free.fr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* $Id: sitter.h,v 1.3 2003/08/04 14:37:14 jerome Exp $ */

#ifndef _sitter_h_
#define _sitter_h_

#include <glib.h>
#include <Imlib.h>
#include "geom.h"

/*
  Interface commune
*/

typedef struct _sitter sitter;
struct _sitter {
  gushort type;
  guint w, h;

  /* avance d'une frame */
  void (*next_frame)(sitter*);

  /* renvoie la frame courante */
  ImlibImage *(*get_current_frame)(sitter*);

  /* dans combien de temps (en 1/10s) doit-on changer de frame
     ou 0 si elle ne change pas */

  gint (*get_next_timeout)(sitter*);

  /* position absolue */
  gint (*get_x)(sitter*, gint, gint, guint, guint);
  gint (*get_y)(sitter*, gint, gint, guint, guint);

  /* hooks */
  void (*structure_notify)(sitter*);
  void (*focus_notify)(sitter*);
};

sitter *sitter_new(gchar*);

/* redirige l ou il faut en fonction du type */
void sitter_free_all(sitter*);

void sitter_free(sitter*);

#endif
