
/*
    xsit - screen mate for X11
    Copyright (C) 2003 Jrme Laheurte <fraca7@free.fr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* $Id: utils.c,v 1.4 2003/08/04 14:40:16 jerome Exp $ */

#include "utils.h"

token_string *token_string_new(gchar *bf, gchar delim) {
  token_string *r = g_new(token_string, 1);
  r->bf = g_strdup(bf);
  r->delim = delim;
  r->pos = 0;
  return r;
}

void token_string_free(token_string *t) {
  g_free(t->bf);
  g_free(t);
}

gboolean token_string_has_more(token_string *t) {
  return ((t->bf)[t->pos] != 0);
}

gchar *token_string_next(token_string *t) {
  gchar *tk;
  gint k = t->pos;

  while (((t->bf)[k] != 0) && ((t->bf)[k] != t->delim)) k++;
  tk = t->bf + t->pos;
  t->pos = ((t->bf)[k] == 0) ? k : k+1;
  (t->bf)[k] = 0;
  return tk;
}

gchar *token_string_remain(token_string *t) {
  return t->bf + t->pos;
}

static const char* _rcsid_utils __attribute__((unused)) = "$Id: utils.c,v 1.4 2003/08/04 14:40:16 jerome Exp $";
